=== debian/changelog ===
velero (1.16.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.16.2 release
  * Update the quilt patch
  * Bump the golang-go version required to build

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 10 Aug 2025 00:09:11 +0200

velero (1.15.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.15.1 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Tue, 14 Jan 2025 14:21:56 +0200

velero (1.14.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.14.0 release
  * Update the quilt patch

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 18 Aug 2024 00:48:51 +0200

velero (1.13.2-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.13.2 release

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 08 May 2024 17:03:46 +0200

velero (1.12.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.12.1 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 03 Nov 2023 13:51:13 +0100

velero (1.11.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.11.1 version
  * Bump the go version required to build velero
  * Remove golang-go as package dependancy

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Mon, 07 Aug 2023 22:33:16 +0100

velero (1.11.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.11.0 version
  * Bump the go version required to build velero

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 10 May 2023 09:36:56 +0100

velero (1.10.0-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.10.0 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Thu, 01 Dec 2022 20:40:07 +0100

velero (1.9.3-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.9.3 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Wed, 23 Nov 2022 22:35:37 +0100

velero (1.9.1-1kaisen) kaisen-packages; urgency=medium

  * Import the 1.9.1 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Sun, 25 Sep 2022 21:52:03 +0100

velero (1.9.0-1kaisen) kaisen-packages; urgency=medium

  * Import 1.9.0 version

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 08 Jul 2022 14:39:04 +0100

velero (1.8.1-2kaisen) kaisen-packages; urgency=medium

  * Update the homepage link in the control file

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 06 May 2022 08:30:03 +0100

velero (1.8.1-1kaisen) kaisen-packages; urgency=medium

  * First packaging for Kaisen Linux

 -- Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>  Fri, 15 Apr 2022 15:10:25 +0200
