=== debian/control ===
Source: velero
Section: admin
Priority: optional
Maintainer: Kevin Chevreuil - Kaisen <kaisen@kaisenlinux.org>
Build-Depends: debhelper-compat (= 13), golang-go (>= 1.23), dh-golang,
Standards-Version: 4.7.2
Homepage: https://velero.io/
Vcs-Browser: https://gitlab.com/kaisenlinux/packages/velero
Vcs-Git: https://gitlab.com/kaisenlinux/packages/velero.git
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/vmware-tanzu/velero

Package: velero
Architecture: amd64 arm64
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: restic
Description: Backup and migrate Kubernetes applications and their persistent volumes
